Index: pacemaker/pengine/test10/migrate-start-complex.exp
===================================================================
--- pacemaker.orig/pengine/test10/migrate-start-complex.exp
+++ pacemaker/pengine/test10/migrate-start-complex.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="5" operation="start" operation_key="top_start_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="top" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -19,7 +19,7 @@
     <action_set>
       <rsc_op id="4" operation="stop" operation_key="top_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="top" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -28,7 +28,7 @@
     <action_set>
       <rsc_op id="9" operation="migrate_from" operation_key="domU-test01_migrate_from_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -41,7 +41,7 @@
     <action_set>
       <rsc_op id="8" operation="migrate_to" operation_key="domU-test01_migrate_to_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -81,7 +81,7 @@
     <action_set>
       <rsc_op id="6" operation="stop" operation_key="domU-test01_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -124,7 +124,7 @@
     <action_set>
       <rsc_op id="16" operation="start" operation_key="dom0-iscsi1-cnx1:1_start_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="dom0-iscsi1-cnx1" long-id="dom0-iscsi1-cnx1:1" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -160,7 +160,7 @@
     <action_set>
       <rsc_op id="25" operation="start" operation_key="bottom:0_start_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="bottom" long-id="bottom:0" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -173,7 +173,7 @@
     <action_set>
       <rsc_op id="2" operation="monitor" operation_key="bottom:0_monitor_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="bottom" long-id="bottom:0" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -182,7 +182,7 @@
     <action_set>
       <rsc_op id="26" operation="start" operation_key="bottom:1_start_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="bottom" long-id="bottom:1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -195,7 +195,7 @@
     <action_set>
       <rsc_op id="3" operation="monitor" operation_key="bottom:1_monitor_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="bottom" long-id="bottom:1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/migrate-start.exp
===================================================================
--- pacemaker.orig/pengine/test10/migrate-start.exp
+++ pacemaker/pengine/test10/migrate-start.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="5" operation="migrate_from" operation_key="domU-test01_migrate_from_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="4" operation="migrate_to" operation_key="domU-test01_migrate_to_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -47,7 +47,7 @@
     <action_set>
       <rsc_op id="2" operation="stop" operation_key="domU-test01_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -87,7 +87,7 @@
     <action_set>
       <rsc_op id="12" operation="start" operation_key="dom0-iscsi1-cnx1:1_start_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="dom0-iscsi1-cnx1" long-id="dom0-iscsi1-cnx1:1" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/migrate-stop-complex.exp
===================================================================
--- pacemaker.orig/pengine/test10/migrate-stop-complex.exp
+++ pacemaker/pengine/test10/migrate-stop-complex.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="3" operation="start" operation_key="top_start_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="top" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -19,7 +19,7 @@
     <action_set>
       <rsc_op id="2" operation="stop" operation_key="top_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="top" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -28,7 +28,7 @@
     <action_set>
       <rsc_op id="7" operation="migrate_from" operation_key="domU-test01_migrate_from_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -41,7 +41,7 @@
     <action_set>
       <rsc_op id="6" operation="migrate_to" operation_key="domU-test01_migrate_to_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -69,7 +69,7 @@
     <action_set>
       <rsc_op id="4" operation="stop" operation_key="domU-test01_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -112,7 +112,7 @@
     <action_set>
       <rsc_op id="14" operation="stop" operation_key="dom0-iscsi1-cnx1:0_stop_0" internal_operation_key="dom0-iscsi1-cnx1:1_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="dom0-iscsi1-cnx1" long-id="dom0-iscsi1-cnx1:0" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -148,7 +148,7 @@
     <action_set>
       <rsc_op id="25" operation="stop" operation_key="bottom:0_stop_0" internal_operation_key="bottom:1_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="bottom" long-id="bottom:0" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/migrate-stop-start-complex.exp
===================================================================
--- pacemaker.orig/pengine/test10/migrate-stop-start-complex.exp
+++ pacemaker/pengine/test10/migrate-stop-start-complex.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="7" operation="migrate_from" operation_key="domU-test01_migrate_from_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="6" operation="migrate_to" operation_key="domU-test01_migrate_to_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -40,7 +40,7 @@
     <action_set>
       <rsc_op id="4" operation="stop" operation_key="domU-test01_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -80,7 +80,7 @@
     <action_set>
       <rsc_op id="14" operation="stop" operation_key="dom0-iscsi1-cnx1:0_stop_0" internal_operation_key="dom0-iscsi1-cnx1:1_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="dom0-iscsi1-cnx1" long-id="dom0-iscsi1-cnx1:0" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -116,7 +116,7 @@
     <action_set>
       <rsc_op id="24" operation="start" operation_key="bottom:0_start_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="bottom" long-id="bottom:0" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -132,7 +132,7 @@
     <action_set>
       <rsc_op id="23" operation="stop" operation_key="bottom:0_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="bottom" long-id="bottom:0" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/migrate-stop.exp
===================================================================
--- pacemaker.orig/pengine/test10/migrate-stop.exp
+++ pacemaker/pengine/test10/migrate-stop.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="5" operation="migrate_from" operation_key="domU-test01_migrate_from_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="4" operation="migrate_to" operation_key="domU-test01_migrate_to_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -40,7 +40,7 @@
     <action_set>
       <rsc_op id="2" operation="stop" operation_key="domU-test01_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -80,7 +80,7 @@
     <action_set>
       <rsc_op id="12" operation="stop" operation_key="dom0-iscsi1-cnx1:0_stop_0" internal_operation_key="dom0-iscsi1-cnx1:1_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="dom0-iscsi1-cnx1" long-id="dom0-iscsi1-cnx1:0" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/migrate-stop_start.exp
===================================================================
--- pacemaker.orig/pengine/test10/migrate-stop_start.exp
+++ pacemaker/pengine/test10/migrate-stop_start.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="5" operation="migrate_from" operation_key="domU-test01_migrate_from_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="4" operation="migrate_to" operation_key="domU-test01_migrate_to_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_migrate_source="dom0-02" CRM_meta_migrate_target="dom0-01" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_record_pending="true" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -47,7 +47,7 @@
     <action_set>
       <rsc_op id="2" operation="stop" operation_key="domU-test01_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="domU-test01" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
+        <attributes CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000" allow_migrate="true"  xmfile="/etc/xen/test01.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -117,7 +117,7 @@
     <action_set>
       <rsc_op id="7" operation="start" operation_key="dom0-iscsi1-cnx1:0_start_0" on_node="dom0-01" on_node_uuid="dom0-01">
         <primitive id="dom0-iscsi1-cnx1" long-id="dom0-iscsi1-cnx1:0" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-01" CRM_meta_on_node_uuid="dom0-01" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -133,7 +133,7 @@
     <action_set>
       <rsc_op id="6" operation="stop" operation_key="dom0-iscsi1-cnx1:0_stop_0" on_node="dom0-02" on_node_uuid="dom0-02">
         <primitive id="dom0-iscsi1-cnx1" long-id="dom0-iscsi1-cnx1:0" class="ocf" provider="heartbeat" type="iscsi"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="dom0-02" CRM_meta_on_node_uuid="dom0-02" CRM_meta_timeout="20000"  portal="192.168.99.1" target="frontal-01:test01"/>
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/minimal.exp
===================================================================
--- pacemaker.orig/pengine/test10/minimal.exp
+++ pacemaker/pengine/test10/minimal.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="8" operation="start" operation_key="rsc1_start_0" on_node="host1" on_node_uuid="host1">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="host1" CRM_meta_on_node_uuid="host1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -22,7 +22,7 @@
     <action_set>
       <rsc_op id="6" operation="monitor" operation_key="rsc1_monitor_0" on_node="host2" on_node_uuid="host2">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="host2" CRM_meta_on_node_uuid="host2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -31,7 +31,7 @@
     <action_set>
       <rsc_op id="4" operation="monitor" operation_key="rsc1_monitor_0" on_node="host1" on_node_uuid="host1">
         <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="host1" CRM_meta_on_node_uuid="host1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -40,7 +40,7 @@
     <action_set>
       <rsc_op id="9" operation="start" operation_key="rsc2_start_0" on_node="host1" on_node_uuid="host1">
         <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="host1" CRM_meta_on_node_uuid="host1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -59,7 +59,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="rsc2_monitor_0" on_node="host2" on_node_uuid="host2">
         <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="host2" CRM_meta_on_node_uuid="host2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -68,7 +68,7 @@
     <action_set>
       <rsc_op id="5" operation="monitor" operation_key="rsc2_monitor_0" on_node="host1" on_node_uuid="host1">
         <primitive id="rsc2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="host1" CRM_meta_on_node_uuid="host1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/mon-rsc-1.exp
===================================================================
--- pacemaker.orig/pengine/test10/mon-rsc-1.exp
+++ pacemaker/pengine/test10/mon-rsc-1.exp
@@ -3,7 +3,7 @@
      <action_set>
       <rsc_op id="5" operation="monitor" operation_key="rsc1_monitor_5000" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_timeout="3000" />
+        <attributes CRM_meta_interval="5000" CRM_meta_name="monitor" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="3000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -16,7 +16,7 @@
      <action_set>
       <rsc_op id="4" operation="start" operation_key="rsc1_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -32,7 +32,7 @@
     <action_set>
       <rsc_op id="3" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="uuid2">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="3000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="uuid2" CRM_meta_op_target_rc="7" CRM_meta_timeout="3000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -41,7 +41,7 @@
      <action_set>
       <rsc_op id="2" operation="monitor" operation_key="rsc1_monitor_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="3000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_op_target_rc="7" CRM_meta_timeout="3000" />
        </rsc_op>
      </action_set>
     <inputs/>
